// Code generated by SQLBoiler 3.6.1 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testSchemas(t *testing.T) {
	t.Parallel()

	query := Schemas()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testSchemasDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testSchemasQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := Schemas().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testSchemasSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := SchemaSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testSchemasExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := SchemaExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if Schema exists: %s", err)
	}
	if !e {
		t.Errorf("Expected SchemaExists to return true, but got false.")
	}
}

func testSchemasFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	schemaFound, err := FindSchema(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if schemaFound == nil {
		t.Error("want a record, got nil")
	}
}

func testSchemasBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = Schemas().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testSchemasOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := Schemas().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testSchemasAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	schemaOne := &Schema{}
	schemaTwo := &Schema{}
	if err = randomize.Struct(seed, schemaOne, schemaDBTypes, false, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}
	if err = randomize.Struct(seed, schemaTwo, schemaDBTypes, false, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = schemaOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = schemaTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Schemas().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testSchemasCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	schemaOne := &Schema{}
	schemaTwo := &Schema{}
	if err = randomize.Struct(seed, schemaOne, schemaDBTypes, false, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}
	if err = randomize.Struct(seed, schemaTwo, schemaDBTypes, false, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = schemaOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = schemaTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func schemaBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func schemaAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Schema) error {
	*o = Schema{}
	return nil
}

func testSchemasHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &Schema{}
	o := &Schema{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, schemaDBTypes, false); err != nil {
		t.Errorf("Unable to randomize Schema object: %s", err)
	}

	AddSchemaHook(boil.BeforeInsertHook, schemaBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	schemaBeforeInsertHooks = []SchemaHook{}

	AddSchemaHook(boil.AfterInsertHook, schemaAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	schemaAfterInsertHooks = []SchemaHook{}

	AddSchemaHook(boil.AfterSelectHook, schemaAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	schemaAfterSelectHooks = []SchemaHook{}

	AddSchemaHook(boil.BeforeUpdateHook, schemaBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	schemaBeforeUpdateHooks = []SchemaHook{}

	AddSchemaHook(boil.AfterUpdateHook, schemaAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	schemaAfterUpdateHooks = []SchemaHook{}

	AddSchemaHook(boil.BeforeDeleteHook, schemaBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	schemaBeforeDeleteHooks = []SchemaHook{}

	AddSchemaHook(boil.AfterDeleteHook, schemaAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	schemaAfterDeleteHooks = []SchemaHook{}

	AddSchemaHook(boil.BeforeUpsertHook, schemaBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	schemaBeforeUpsertHooks = []SchemaHook{}

	AddSchemaHook(boil.AfterUpsertHook, schemaAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	schemaAfterUpsertHooks = []SchemaHook{}
}

func testSchemasInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testSchemasInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(schemaColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testSchemasReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testSchemasReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := SchemaSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testSchemasSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Schemas().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	schemaDBTypes = map[string]string{`ID`: `INTEGER`}
	_             = bytes.MinRead
)

func testSchemasUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(schemaPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(schemaAllColumns) == len(schemaPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testSchemasSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(schemaAllColumns) == len(schemaPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Schema{}
	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Schemas().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, schemaDBTypes, true, schemaPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Schema struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(schemaAllColumns, schemaPrimaryKeyColumns) {
		fields = schemaAllColumns
	} else {
		fields = strmangle.SetComplement(
			schemaAllColumns,
			schemaPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := SchemaSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}
